<?php
    global $VISUAL_COMPOSER_EXTENSIONS;
	if ((class_exists('WPBakeryShortCode')) && (!class_exists('WPBakeryShortCode_TS_VCSC_Facebook_Video'))) {
		class WPBakeryShortCode_TS_VCSC_Facebook_Video extends WPBakeryShortCode {};
	};
    $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_VisualComposer_Element = array(
		"name"                          	=> __( "TS Video Facebook", "ts_visual_composer_extend" ),
		"base"                          	=> "TS_VCSC_Facebook_Video",
		"icon" 	                        	=> "ts-composer-element-icon-facebookvideo",
		"category"                      	=> __( "VC Extensions", "ts_visual_composer_extend" ),
		"description"                   	=> __("Place a Facebook Video", "ts_visual_composer_extend"),
		"admin_enqueue_js"              	=> "",
		"admin_enqueue_css"             	=> "",
		"params"                        	=> array(
			// Facebook Video
			array(
				"type"                  	=> "seperator",
				"param_name"            	=> "seperator_1",
				"seperator"             	=> "Facebook Video",
			),
			array(
				"type"						=> "messenger",
				"param_name"				=> "messenger1",
				"size"						=> "13",
				"message"					=> __( "Please ensure that your video is set to be publicly available, as you will not be able to show private or restricted videos.", "ts_visual_composer_extend" ),
				"layout"					=> "notice",
				"level"						=> "warning",
			),
			array(
				"type"                  	=> "textfield",
				"heading"               	=> __( "Facebook Video URL", "ts_visual_composer_extend" ),
				"param_name"            	=> "facebook_video",
				"value"                 	=> "",
				"admin_label"           	=> true,
				"description"           	=> __( "Enter the URL for the Facebook video.", "ts_visual_composer_extend" ),
			),
			array(
				"type"              		=> "switch_button",
				"heading"			    	=> __( "Autoplay Video", "ts_visual_composer_extend" ),
				"param_name"		    	=> "facebook_autoplay",
				"value"             		=> "false",
				"description"		    	=> __( "Switch the toggle if you want to auto-play the video once opened in the lightbox or on pageload (iFrame).", "ts_visual_composer_extend" ),
			),
			array(
				"type"                  	=> "dropdown",
				"heading"               	=> __( "Video Ratio", "ts_visual_composer_extend" ),
				"param_name"            	=> "facebook_ratio",
				"value"                 	=> array(
					__("1.33:1 (4:3)", "ts_visual_composer_extend")          			=> "ts-ratio-four-to-three",
					__("1.67:1 (3:2)", "ts_visual_composer_extend")         			=> "ts-ratio-three-to-two",
					__("1.60:1 (8:5)", "ts_visual_composer_extend")         			=> "ts-ratio-eight-to-five",
					__("1.78:1 (16:9)", "ts_visual_composer_extend")					=> "ts-ratio-sixteen-to-nine",
					__("1.85:1", "ts_visual_composer_extend")							=> "ts-ratio-oneeightfive-to-one",
					__("2.33:1 (21:9)", "ts_visual_composer_extend")					=> "ts-ratio-twentyone-to-nine",
					__("2.39:1", "ts_visual_composer_extend")							=> "ts-ratio-twothreenine-to-one",
					__("2.67:1", "ts_visual_composer_extend")							=> "ts-ratio-twosixseven-to-one",
					__("2.75:1", "ts_visual_composer_extend")							=> "ts-ratio-twosevenfive-to-one",
					__("3.75:1", "ts_visual_composer_extend")							=> "ts-ratio-threesevenfive-to-one",
				),
				"description"           	=> __( "Select the width-to-height ratio that the video to be shown within the iFrame is encoded with.", "ts_visual_composer_extend" ),
				"default"					=> 'ts-ratio-sixteen-to-nine',
				"standard"					=> 'ts-ratio-sixteen-to-nine',
				"std"						=> 'ts-ratio-sixteen-to-nine',
				"dependency"            	=> array( 'element' => "lightbox_open", 'value' => 'false' ),
			),
			
			
			
			// Lightbox Settings
			array(
				"type"				    	=> "seperator",
				"param_name"		    	=> "seperator_5",
				"seperator"					=> "Lightbox Settings",
				"group" 					=> "Lightbox",
			),
			array(
				"type"              		=> "switch_button",
				"heading"           		=> __( "Show in Lightbox", "ts_visual_composer_extend" ),
				"param_name"        		=> "lightbox_open",
				"value"             		=> "false",
				"description"       		=> __( "Switch the toggle if the video should be opened within a lightbox.", "ts_visual_composer_extend" ),
				"admin_label"           	=> true,
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "dropdown",
				"heading"               	=> __( "Maximum Lightbox Width", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_width",
				"width"                 	=> 150,
				"value"                 	=> array(
					__( 'Auto', "ts_visual_composer_extend" )                 	=> "auto",
					__( 'Set Width (%)', "ts_visual_composer_extend" )        	=> "widthpercent",
					__( 'Set Width (px)', "ts_visual_composer_extend" )       	=> "widthpixel",
				),
				"description"           	=> __( "Select how the maximum element width inside the lightbox should be determined.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_open", 'value' => 'true' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "nouislider",
				"heading"               	=> __( "Maximum Lightbox Width", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_width_percent",
				"value"                 	=> "100",
				"min"                   	=> "25",
				"max"                   	=> "100",
				"step"                  	=> "1",
				"unit"                  	=> '%',
				"description"           	=> __( "Select the maximum element width inside the lightbox in percent.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_width", 'value' => 'widthpercent' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "nouislider",
				"heading"               	=> __( "Maximum Lightbox Width", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_width_pixel",
				"value"                 	=> "960",
				"min"                   	=> "1",
				"max"                  	 	=> "1920",
				"step"                  	=> "1",
				"unit"                  	=> 'px',
				"description"           	=> __( "Select the maximum element width inside the lightbox in px.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_width", 'value' => 'widthpixel' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "dropdown",
				"heading"               	=> __( "Maximum Lightbox Height", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_height",
				"width"                 	=> 150,
				"value"                 	=> array(
					__( 'Auto', "ts_visual_composer_extend" )                 	=> "auto",
					__( 'Set Height (%)', "ts_visual_composer_extend" )      	=> "heightpercent",
					__( 'Set Height (px)', "ts_visual_composer_extend" )      	=> "heightpixel",
				),
				"description"           	=> __( "Select how the maximum element height inside the lightbox should be determined.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_open", 'value' => 'true' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "nouislider",
				"heading"               	=> __( "Maximum Lightbox Height", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_height_percent",
				"value"                 	=> "100",
				"min"                   	=> "25",
				"max"                   	=> "100",
				"step"                  	=> "1",
				"unit"                  	=> '%',
				"description"           	=> __( "Select the maximum element height inside the lightbox in percent.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_height", 'value' => 'heightpercent' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "nouislider",
				"heading"               	=> __( "Maximum Lightbox Height", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_height_pixel",
				"value"                 	=> "540",
				"min"                   	=> "100",
				"max"                   	=> "1080",
				"step"                  	=> "1",
				"unit"                  	=> 'px',
				"description"           	=> __( "Select the maximum element height inside the lightbox in px.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_height", 'value' => 'heightpixel' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "textfield",
				"heading"               	=> __( "Group Name", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_group_name",
				"value"                 	=> "nachogroup",
				"description"           	=> __( "Enter a custom group name to manually build group with other video items; leave empty for non-grouping", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_open", 'value' => "true" ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "dropdown",
				"heading"               	=> __( "Transition Effect", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_effect",
				"width"                 	=> 150,
				"value"                 	=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Lightbox_Animations,
				"default" 					=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_LightboxDefaultAnimation,
				"std" 						=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_LightboxDefaultAnimation,
				"description"           	=> __( "Select the transition effect to be used for the image in the lightbox.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_open", 'value' => 'true' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "dropdown",
				"heading"               	=> __( "Backlight Color", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_backlight_choice",
				"width"                 	=> 150,
				"value"                 	=> array(
					__( 'Predefined Color', "ts_visual_composer_extend" )			=> "predefined",
					__( 'Custom Color', "ts_visual_composer_extend" )				=> "customized",
					__( 'Transparent Backlight', "ts_visual_composer_extend" )     	=> "hideit",
				),
				"description"           	=> __( "Select the (backlight) color style for the popup box.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_open", 'value' => 'true' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"                  	=> "dropdown",
				"heading"               	=> __( "Select Backlight Color", "ts_visual_composer_extend" ),
				"param_name"            	=> "lightbox_backlight_color",
				"width"                 	=> 150,
				"value"                 	=> array(
					__( 'Default', "ts_visual_composer_extend" )      		=> "#0084E2",
					__( 'Neutral', "ts_visual_composer_extend" )      		=> "#FFFFFF",
					__( 'Success', "ts_visual_composer_extend" )      		=> "#4CFF00",
					__( 'Warning', "ts_visual_composer_extend" )      		=> "#EA5D00",
					__( 'Error', "ts_visual_composer_extend" )        		=> "#CC0000",
					__( 'None', "ts_visual_composer_extend" )         		=> "#000000",
				),
				"description"           	=> __( "Select the predefined backlight color for the modal popup.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_backlight_choice", 'value' => 'predefined' ),
				"group" 					=> "Lightbox",
			),
			array(
				"type"              		=> "colorpicker",
				"heading"           		=> __( "Select Backlight Color", "ts_visual_composer_extend" ),
				"param_name"        		=> "lightbox_backlight_custom",
				"value"             		=> "#000000",
				"description"       		=> __( "Define a custom backlight color for the modal popup.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_backlight_choice", 'value' => 'customized' ),
				"group" 					=> "Lightbox",
			),
			// Trigger Settings
			array(
				"type"				    	=> "seperator",
				"param_name"		    	=> "seperator_2",
				"seperator"					=> "Trigger",
				"dependency"            	=> array( 'element' => "lightbox_open", 'value' => 'true' ),
				"group" 					=> "Trigger",
			),
			array(
				"type"                  	=> "dropdown",
				"heading"               	=> __( "Trigger Type", "ts_visual_composer_extend" ),
				"param_name"            	=> "content_trigger",
				"value"                 	=> array(
					__("Facebook Cover", "ts_visual_composer_extend")      		=> "preview",
					__("Default Image", "ts_visual_composer_extend")          	=> "default",
					__("Custom Image", "ts_visual_composer_extend")           	=> "image",
					__("Font Icon", "ts_visual_composer_extend")              	=> "icon",
					__("Winged Button", "ts_visual_composer_extend")          	=> "winged",
					__("Simple Button", "ts_visual_composer_extend")          	=> "simple",
					__("Flat Icon Button", "ts_visual_composer_extend")       	=> "flaticon",
					__("Flat Button", "ts_visual_composer_extend")       		=> "flat",
					__("Text", "ts_visual_composer_extend")                   	=> "text",
					__("Custom HTML", "ts_visual_composer_extend")            	=> "custom",
				),
				"description"           	=> __( "Select the type of trigger to click on in order to show the lightbox.", "ts_visual_composer_extend" ),
				"dependency"            	=> array( 'element' => "lightbox_open", 'value' => 'true' ),
				"group" 					=> "Trigger",
			),
			// Custom Image
			array(
				"type"                  => "attach_image",
				"heading"               => __( "Select Image", "ts_visual_composer_extend" ),
				"param_name"            => "content_image",
				"value"                 => "",
				"description"           => __( "Select the preview image for the lightbox content.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => 'image' ),
				"group" 				=> "Trigger",
			),
			array(
				"type"              	=> "switch_button",
				"heading"			    => __( "Simple Image Only", "ts_visual_composer_extend" ),
				"param_name"		    => "content_image_simple",
				"value"             	=> "false",
				"description"		    => __( "Switch the toggle if you want display just the image without any styling.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => 'image' ),
				"group" 				=> "Trigger",
			),
			array(
				"type"                  => "dropdown",
				"heading"               => __( "Auto Height Setting", "ts_visual_composer_extend" ),
				"param_name"            => "content_image_height",
				"width"                 => 150,
				"value"                 => array(
					__( '100% Height Setting', "ts_visual_composer_extend" )		=> "height: 100%;",
					__( 'Auto Height Setting', "ts_visual_composer_extend" )     	=> "height: auto;",
				),
				"description"           => __( "Select what CSS height setting should be applied to the image (change only if image height does not display correctly).", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => array('preview', 'default', 'image') ),
				"group" 				=> "Trigger",
			),
			array(
				"type" 					=> "icons_panel",
				'heading' 				=> __( 'Select Icon', 'ts_visual_composer_extend' ),
				'param_name' 			=> 'content_icon',
				'value'					=> '',
				"settings" 				=> array(
					"emptyIcon" 				=> false,
					'emptyIconValue'			=> 'transparent',
					"type" 						=> 'extensions',
				),
				"description"       	=> ($VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_EditorVisualSelector == "true" ? __( "Select the icon you want to display.", "ts_visual_composer_extend" ) : $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_IconSelectorString),
				"dependency"            => array( 'element' => "content_trigger", 'value' => array('icon', 'flaticon') ),
				"group" 				=> "Trigger",
			),				
			array(
				"type"                  => "nouislider",
				"heading"               => __( "Icon Size", "ts_visual_composer_extend" ),
				"param_name"            => "content_iconsize",
				"value"                 => "30",
				"min"                   => "16",
				"max"                   => "512",
				"step"                  => "1",
				"unit"                  => 'px',
				"description"           => __( "Select the icon / image size", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => 'icon' ),
				"group" 				=> "Trigger",
			),
			array(
				"type"                  => "colorpicker",
				"heading"               => __( "Icon Color", "ts_visual_composer_extend" ),
				"param_name"            => "content_iconcolor",
				"value"                 => "#cccccc",
				"description"           => __( "Define the color of the icon.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => 'icon' ),
				"group" 				=> "Trigger",
			),
			// Flat Button
			array(
				"type"                  => "dropdown",
				"heading"               => __( "Button Color Style", "ts_visual_composer_extend" ),
				"param_name"            => "content_buttonstyle",
				"width"                 => 300,
				"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Flat_Button_Default_Colors,
				"description"           => __( "Select the general color style for button.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => array('flat', 'flaticon') ),
				"group" 				=> "Trigger",
			),
			array(
				"type"                  => "dropdown",
				"heading"               => __( "Button Hover Style", "ts_visual_composer_extend" ),
				"param_name"            => "content_buttonhover",
				"width"                 => 300,
				"value"                 => $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Flat_Button_Hover_Colors,
				"description"           => __( "Select the general hover style for button.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => array('flat', 'flaticon') ),
				"group" 				=> "Trigger",
			),
			// Button
			array(
				"type"                  => "textfield",
				"heading"               => __( "Button Text", "ts_visual_composer_extend" ),
				"param_name"            => "content_buttontext",
				"value"                 => "View Video",
				"description"           => __( "Enter the text for the button.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => array('winged', 'simple', 'flat', 'flaticon') ),
				"group" 				=> "Trigger",
			),
			array(
				"type"                  => "nouislider",
				"heading"               => __( "Button Text Size", "ts_visual_composer_extend" ),
				"param_name"            => "content_buttonsize",
				"value"                 => "16",
				"min"                   => "12",
				"max"                   => "20",
				"step"                  => "1",
				"unit"                  => 'px',
				"description"           => __( "Select the top margin for the element.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => array('flat', 'flaticon') ),
				"group" 				=> "Trigger",
			),
			// Text Link
			array(
				"type"                  => "textfield",
				"heading"               => __( "Trigger Text", "ts_visual_composer_extend" ),
				"param_name"            => "content_text",
				"value"                 => "",
				"description"           => __( "Enter the trigger text for the video.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => 'text' ),
				"group" 				=> "Trigger",
			),
			// Custom Code
			array(
				"type"                  => "textarea_raw_html",
				"heading"               => __("Raw HTML", "ts_visual_composer_extend"),
				"param_name"            => "content_raw",
				"value"                 => base64_encode(""),
				"description"           => __("Enter your custom HTML code; code will be wrapped in appropriate link automatically.", "ts_visual_composer_extend"),
				"dependency"            => array( 'element' => "content_trigger", 'value' => 'custom' ),
				"group" 				=> "Trigger",
			),
			// Title + Subtitle
			array(
				"type"                  => "textfield",
				"heading"               => __( "Title", "ts_visual_composer_extend" ),
				"param_name"            => "content_title",
				"value"                 => "",
				"description"           => __( "Enter a title for the lightbox content.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => array('image', 'default', 'preview', 'winged', 'flat', 'flaticon') ),
				"group" 				=> "Trigger",
			),
			array(
				"type"                  => "textfield",
				"heading"               => __( "Subtitle", "ts_visual_composer_extend" ),
				"param_name"            => "content_subtitle",
				"value"                 => "",
				"description"           => __( "Enter a subtitle for the lightbox content.", "ts_visual_composer_extend" ),
				"dependency"            => array( 'element' => "content_trigger", 'value' => array('winged') ),
				"group" 				=> "Trigger",
			),				
			// Overlay Settings
			array(
				"type"                  	=> "seperator",
				"param_name"            	=> "seperator_7",
				"seperator"             	=> "Overlay Settings",
				"dependency"        		=> array( 'element' => "content_trigger", 'value' => array('preview', 'default', 'image', 'poster') ),				
				"group" 					=> "Trigger",
			),			
			array(
				"type"              		=> "colorpicker",
				"heading"           		=> __( "Overlay: Background Color", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_background",
				"value"             		=> "rgba(24, 24, 24, 0.3)",
				"description"       		=> __( "Select the background color and opacity for the overlay.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "content_trigger", 'value' => array('preview', 'default', 'image', 'poster') ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",	
				"group" 					=> "Trigger"
			),		
			array(
				"type"              		=> "dropdown",
				"heading"           		=> __( "Overlay: Animation", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_animation",
				"width"             		=> 300,
				"value"             		=> array(
					__( "Zoom Effect", "ts_visual_composer_extend" )				=> "zoom",
					__( "Zoom + Rotate Effect", "ts_visual_composer_extend" )		=> "rotate",
					__( "No Effect", "ts_visual_composer_extend" )					=> "none",
				),
				"description"       		=> __( "Select if and what type of animation should be applied to the image on hover.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "content_trigger", 'value' => array('preview', 'default', 'image', 'poster') ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"group" 					=> "Trigger"
			),			
			array(
				"type"              		=> "dropdown",
				"heading"           		=> __( "Overlay: Decoration", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_decoration",
				"width"             		=> 300,
				"value"             		=> array(
					__( "Default Image", "ts_visual_composer_extend" )				=> "default",
					__( "Custom Internal Image", "ts_visual_composer_extend" )		=> "image",
					__( "Custom External Image", "ts_visual_composer_extend" )		=> "external",
					__( "Font Icon", "ts_visual_composer_extend" )					=> "icon",
					__( "No Decoration", "ts_visual_composer_extend" )				=> "none",
				),
				"description"       		=> __( "Select if and how the overlay should be decorated.", "ts_visual_composer_extend" ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"dependency"        		=> array( 'element' => "content_trigger", 'value' => array('preview', 'preview', 'default', 'image', 'poster') ),
				"group" 					=> "Trigger",
			),
			array(
				"type"              		=> "dropdown",
				"heading"           		=> __( "Overlay: Visibility", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_visibility",
				"width"             		=> 300,
				"value"             		=> array(
					__( "Show Only On Hover", "ts_visual_composer_extend" )			=> "hover",
					__( "Always Show Decoration", "ts_visual_composer_extend" )		=> "only_deco",
					__( "Always Show Title", "ts_visual_composer_extend" )			=> "only_title",
					__( "Always Show Full Overlay", "ts_visual_composer_extend" )	=> "always",
				),
				"admin_label"           	=> true,
				"description"       		=> __( "Select if and when the overlay should be visible.", "ts_visual_composer_extend" ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"dependency"        		=> array( 'element' => "content_trigger", 'value' => array('preview', 'preview', 'default', 'image', 'poster') ),
				"group" 					=> "Trigger",
			),			
			array(
				"type"              		=> "attach_image",
				"heading"           		=> __( "Overlay: Decoration Image", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_image",
				"value"             		=> "",
				"description"       		=> __( "Select an image to be used as decoration for the overlay.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "overlay_decoration", 'value' => 'image' ),
				"group" 					=> "Trigger",
			),	
			array(
				"type"              		=> "textfield",
				"heading"           		=> __( "Overlay: Decoration Image", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_external",
				"value"             		=> "",
				"description"       		=> __( "Enter the full path to the image to be used as decoration for the overlay.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "overlay_decoration", 'value' => 'external' ),
				"group" 					=> "Trigger",
			),
			array(
				"type" 						=> "icons_panel",
				'heading' 					=> __( 'Overlay: Decoration Icon', 'ts_visual_composer_extend' ),
				'param_name' 				=> 'overlay_icon_name',
				'value'						=> '',
				"settings" 					=> array(
					"emptyIcon" 					=> false,
					'emptyIconValue'				=> 'transparent',
					"type" 							=> 'extensions',
				),
				"description"       		=> ($VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_EditorVisualSelector == "true" ? __( "Select the icon to be used as decoration for the overlay.", "ts_visual_composer_extend" ) : $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_IconSelectorString),
				"dependency"        		=> array( 'element' => "overlay_decoration", 'value' => 'icon' ),
				"group" 					=> "Trigger",
			),			
			array(
				"type"              		=> "colorpicker",
				"heading"           		=> __( "Overlay: Decoration Color", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_icon_color",
				"value"             		=> "#ededed",
				"description"       		=> __( "Select the color for the decoration element.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "overlay_decoration", 'value' => 'icon' ),
				"group" 					=> "Trigger",
			),
			array(
				"type"                  	=> "nouislider",
				"heading"               	=> __( "Overlay: Decoration Size", "ts_visual_composer_extend" ),
				"param_name"           	 	=> "overlay_size",
				"value"                 	=> "100",
				"min"                   	=> "50",
				"max"                   	=> "200",
				"step"                  	=> "1",
				"unit"                  	=> 'px',
				"description"           	=> __( "Define the size of the decoration element in the overlay.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "overlay_decoration", 'value' => array('icon', 'image', 'external') ),
				"group" 					=> "Trigger",
			),
			array(
				"type"                  	=> "nouislider",
				"heading"               	=> __( "Overlay: Decoration Opacity", "ts_visual_composer_extend" ),
				"param_name"            	=> "overlay_opacity",
				"value"                 	=> "75",
				"min"                   	=> "50",
				"max"                   	=> "100",
				"step"                  	=> "1",
				"unit"                  	=> '%',
				"description"           	=> __( "Define the opacity of the decoration element in the overlay.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "overlay_decoration", 'value' => array('icon', 'image', 'external') ),
				"group" 					=> "Trigger",
			),
			array(
				"type"              		=> "colorpicker",
				"heading"           		=> __( "Overlay: Title Color", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_title_color",
				"value"             		=> "#ffffff",
				"description"       		=> __( "Select the font color for the overlay title.", "ts_visual_composer_extend" ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"dependency"        		=> array( 'element' => "content_trigger", 'value' => array('preview', 'default', 'image', 'poster') ),
				"group" 					=> "Trigger",
			),
			array(
				"type"              		=> "colorpicker",
				"heading"           		=> __( "Overlay: Title Background", "ts_visual_composer_extend" ),
				"param_name"        		=> "overlay_title_back",
				"value"             		=> "rgba(0, 0, 0, 0.4)",
				"description"       		=> __( "Select the background color and opacity for the overlay title.", "ts_visual_composer_extend" ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"dependency"        		=> array( 'element' => "content_trigger", 'value' => array('preview', 'default', 'image', 'poster') ),
				"group" 					=> "Trigger",
			),
			// Tooltip Settings
			array(
				"type"              		=> "seperator",
				"param_name"        		=> "seperator_10",
				"seperator"            		=> "Tooltip Settings",
				"group" 					=> "Tooltip",
			),
			array(
				"type"						=> "switch_button",
				"heading"           		=> __( "Tooltip Addition", "ts_visual_composer_extend" ),
				"param_name"        		=> "tooltip_usage",
				"value"            	 		=> "false",
				"description"       		=> __( "Switch the toggle if you want to add an optional tooltip to the element.", "ts_visual_composer_extend" ),
				"group" 					=> "Tooltip",
			),
			array(
				"type"              		=> ($VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_EditorBase64TinyMCE == "true" ? "wysiwyg_base64" : "textarea_raw_html"),
				"heading"           		=> __( "Tooltip Content", "ts_visual_composer_extend" ),
				"param_name"        		=> "tooltip_content",
				"minimal"					=> "true",
				"value"             		=> base64_encode(""),
				"description"      	 		=> __( "Enter the tooltip content for the element; basic HTML code can be used.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "tooltip_usage", 'value' => 'true' ),
				"group" 					=> "Tooltip",
			),
			array(
				"type"						=> "switch_button",
				"heading"           		=> __( "Tooltip Arrow", "ts_visual_composer_extend" ),
				"param_name"        		=> "tooltip_arrow",
				"value"             		=> "true",
				"description"       		=> __( "Switch the toggle to either show or hide the tooltip arrow.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "tooltip_usage", 'value' => 'true' ),
				"group" 					=> "Tooltip",
			),
			array(
				"type"						=> "dropdown",
				"heading"					=> __( "Tooltip Position", "ts_visual_composer_extend" ),
				"param_name"				=> "tooltip_position",
				"value"						=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_ToolTipster_Positions,
				"description"				=> __( "Select the tooltip position in relation to the element.", "ts_visual_composer_extend" ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"dependency"        		=> array( 'element' => "tooltip_usage", 'value' => 'true' ),
				"group" 					=> "Tooltip",
			),
			array(
				"type"				    	=> "dropdown",
				"heading"			    	=> __( "Tooltip Animation", "ts_visual_composer_extend" ),
				"param_name"		   	 	=> "tooltip_animation",
				"value"                 	=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_ToolTipster_Animations,
				"description"		    	=> __( "Select how the tooltip entry and exit should be animated once triggered.", "ts_visual_composer_extend" ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"dependency"        		=> array( 'element' => "tooltip_usage", 'value' => 'true' ),
				"group"						=> "Tooltip",
			),	
			array(
				"type"						=> "dropdown",
				"heading"					=> __( "Tooltip Style", "ts_visual_composer_extend" ),
				"param_name"				=> "tooltip_style",
				"value"             		=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_ToolTipster_Styles,
				"description"				=> __( "Select the tooltip style.", "ts_visual_composer_extend" ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"dependency"        		=> array( 'element' => "tooltip_usage", 'value' => 'true' ),
				"group" 					=> "Tooltip",
			),
			array(
				"type"              		=> "colorpicker",
				"heading"           		=> __( "Tooltip Font Color", "ts_visual_composer_extend" ),
				"param_name"        		=> "tooltip_color",
				"value"             		=> "#ffffff",
				"description"       		=> __( "Define the custom font color for the tooltip.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "tooltip_style", 'value' => array('tooltipster-custom', 'ts-simptip-style-custom') ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"group" 					=> "Tooltip",
			),		
			array(
				"type"              		=> "colorpicker",
				"heading"           		=> __( "Tooltip Background Color", "ts_visual_composer_extend" ),
				"param_name"        		=> "tooltip_background",
				"value"             		=> "#000000",
				"description"       		=> __( "Define the custom background color for the tooltip.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "tooltip_style", 'value' => array('tooltipster-custom', 'ts-simptip-style-custom') ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"group" 					=> "Tooltip",
			),
			array(
				"type"              		=> "colorpicker",
				"heading"           		=> __( "Tooltip Border Color", "ts_visual_composer_extend" ),
				"param_name"        		=> "tooltip_border",
				"value"             		=> "#000000",
				"description"       		=> __( "Define the custom border color for the tooltip.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "tooltip_style", 'value' => array('tooltipster-custom', 'ts-simptip-style-custom') ),
				"edit_field_class"			=> "vc_col-sm-6 vc_column",
				"group" 					=> "Tooltip",
			),	
			array(
				"type"						=> "nouislider",
				"heading"					=> __( "Tooltip X-Offset", "ts_visual_composer_extend" ),
				"param_name"				=> "tooltip_offsetx",
				"value"						=> "0",
				"min"						=> "-100",
				"max"						=> "100",
				"step"						=> "1",
				"unit"						=> 'px',
				"description"				=> __( "Define an optional X-Offset for the tooltip position.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "tooltip_usage", 'value' => 'true' ),
				"group" 					=> "Tooltip",
			),
			array(
				"type"						=> "nouislider",
				"heading"					=> __( "Tooltip Y-Offset", "ts_visual_composer_extend" ),
				"param_name"				=> "tooltip_offsety",
				"value"						=> "0",
				"min"						=> "-100",
				"max"						=> "100",
				"step"						=> "1",
				"unit"						=> 'px',
				"description"				=> __( "Define an optional Y-Offset for the tooltip position.", "ts_visual_composer_extend" ),
				"dependency"        		=> array( 'element' => "tooltip_usage", 'value' => 'true' ),
				"group" 					=> "Tooltip",
			),
			// Other Settings
			array(
				"type"				    	=> "seperator",
				"param_name"		    	=> "seperator_6",
				"seperator"					=> "Other Settings",
				"group" 					=> "Other Settings",
			),
			array(
				"type"                  	=> "nouislider",
				"heading"               	=> __( "Margin: Top", "ts_visual_composer_extend" ),
				"param_name"            	=> "margin_top",
				"value"                 	=> "0",
				"min"                   	=> "0",
				"max"                   	=> "200",
				"step"                  	=> "1",
				"unit"                  	=> 'px',
				"description"           	=> __( "Select the top margin for the element.", "ts_visual_composer_extend" ),
				"group" 					=> "Other Settings",
			),
			array(
				"type"                  	=> "nouislider",
				"heading"               	=> __( "Margin: Bottom", "ts_visual_composer_extend" ),
				"param_name"            	=> "margin_bottom",
				"value"                 	=> "0",
				"min"                   	=> "0",
				"max"                   	=> "200",
				"step"                  	=> "1",
				"unit"                  	=> 'px',
				"description"           	=> __( "Select the bottom margin for the element.", "ts_visual_composer_extend" ),
				"group" 					=> "Other Settings",
			),
			array(
				"type"                  	=> "textfield",
				"heading"               	=> __( "Define ID Name", "ts_visual_composer_extend" ),
				"param_name"            	=> "el_id",
				"value"                 	=> "",
				"description"           	=> __( "Enter an unique ID for the element.", "ts_visual_composer_extend" ),
				"group" 					=> "Other Settings",
			),
			array(
				"type"                  	=> "tag_editor",
				"heading"           		=> __( "Extra Class Names", "ts_visual_composer_extend" ),
				"param_name"            	=> "el_class",
				"value"                 	=> "",
				"description"      			=> __( "Enter additional class names for the element.", "ts_visual_composer_extend" ),
				"group" 					=> "Other Settings",
			),
		)
	);	
	if ($VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_VisualComposer_LeanMap == "true") {
		return $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_VisualComposer_Element;
	} else {			
		vc_map($VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_VisualComposer_Element);
	};
?>