<?php
  if ( ! defined( 'ABSPATH' ) ) { exit; }

// **********************************************************************// 

// ! Register New Element: WD Specific Product

// **********************************************************************//
global $VISUAL_COMPOSER_EXTENSIONS;
$specipic_product_params = array(
	"name"                      => esc_html__( "TS Counter No Icon", "wdjewelry" ),
            "base"                      => "Counter_militonre",
            "icon" 	                    => "icon-wpb-ts_vcsc_icon_counter",
            "class"                     => "",
            "category"                  => esc_html__( "WPDance Elements", "wdjewelry" ),
            "description"               => esc_html__("Place an icon counter element", "wdjewelry"),
            "admin_enqueue_js"			=> "",
            "admin_enqueue_css"			=> "",
            "params"                    => array(				
               				
				array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'wdjewelry'),
						"admin_label" => true,
						"param_name" => "style",
						"value" => array(
							"Style 1" => 'style1',
							"Style 2" => 'style2',
							"Style 3" => 'style3'
						),
						"description" => '',
					),
                // Main Counter Settings
				array(
					"type"              => "seperator",
					"heading"           => esc_html__( "", "wdjewelry" ),
					"param_name"        => "seperator_3",
					"value"				=> "",
					"seperator"			=> "Counter Values",
					"description"       => esc_html__( "", "wdjewelry" ),
					"group" 			=> "Value Settings",
				),
				array(
					"type"				=> "switch_button",
					"heading"           => esc_html__( "Trigger on Viewport", "wdjewelry" ),
					"param_name"        => "counter_viewport",
					"value"             => "true",
					"on"				=> esc_html__( 'Yes', "wdjewelry" ),
					"off"				=> esc_html__( 'No', "wdjewelry" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
					"description"       => esc_html__( "Switch the toggle to trigger the counter on viewport or on pageload.", "wdjewelry" ),
                    "dependency"        => "",
					"group" 			=> "Value Settings",
				),
                array(
                    "type"              => "textfield",
                    "heading"           => esc_html__( "Counter Start Number", "wdjewelry" ),
                    "param_name"        => "counter_value_start",
                    "value"             => 0,
                    "admin_label"       => true,
                    "description"       => esc_html__( "Enter the number to start counting from.", "wdjewelry" ),
					"group" 			=> "Value Settings",
                ),				
				array(
					"type"				=> "switch_button",
					"heading"           => esc_html__( "Use Shortcode for Counter End Number", "wdjewelry" ),
					"param_name"        => "counter_value_by_shortcode",
					"value"             => "false",
					"on"				=> esc_html__( 'Yes', "wdjewelry" ),
					"off"				=> esc_html__( 'No', "wdjewelry" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
					"description"       => esc_html__( "Switch the toggle if you want to use a shortcode to generate the end value for the counter.", "wdjewelry" ),
                    "dependency"        => "",
					"group" 			=> "Value Settings",
				),				
                array(
                    "type"              => "textfield",
                    "heading"           => esc_html__( "Counter End Number", "wdjewelry" ),
                    "param_name"        => "counter_value_end",
                    "value"             => "",
                    "admin_label"       => true,
                    "description"       => esc_html__( "Enter the number to count up to.", "wdjewelry" ),
					"dependency"        => array( 'element' => "counter_value_by_shortcode", 'value' => 'false' ),
					"group" 			=> "Value Settings",
                ),
				array(
					"type"              => "textarea_raw_html",
					"heading"           => esc_html__( "Counter End Number", "wdjewelry" ),
					"param_name"        => "counter_value_end_shortcode",
					"value"             =>'',
					"description"       => esc_html__( "Enter the shortcode that will dynamically generate the counter end value.", "wdjewelry" ),
					"dependency"        => array( 'element' => "counter_value_by_shortcode", 'value' => 'true' ),
					"group" 			=> "Value Settings",
				),
				array(
					"type"              => "nouislider",
					"heading"           => esc_html__( "Counter Number Font Size", "wdjewelry" ),
					"param_name"        => "counter_value_size",
					"value"             => "30",
					"min"               => "12",
					"max"               => "200",
					"step"              => "1",
					"unit"              => 'px',
					"description"       => esc_html__( "Select the font size for the counter number.", "wdjewelry" ),
					"dependency"        => "",
					"group" 			=> "Value Settings",
				),
				array(
					"type"              => "colorpicker",
					"heading"           => esc_html__( "Counter Number Font Color", "wdjewelry" ),
					"param_name"        => "counter_value_color",
					"value"             => "#000000",
					"description"       => esc_html__( "Define the font color for counter number.", "wdjewelry" ),
					"dependency"        => "",
					"group" 			=> "Value Settings",
				),
				array(
					"type"				=> "switch_button",
					"heading"           => esc_html__( "Format Finished Number", "wdjewelry" ),
					"param_name"        => "counter_value_format",
					"value"             => "false",
					"on"				=> esc_html__( 'Yes', "wdjewelry" ),
					"off"				=> esc_html__( 'No', "wdjewelry" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
					"description"       => esc_html__( "Switch the toggle to add some formatting to the number once the count has finished.", "wdjewelry" ),
                    "dependency"        => "",
					"group" 			=> "Value Settings",
				),
				array(
					"type"				=> "switch_button",
					"heading"           => esc_html__( "Add '+' Sign to Number", "wdjewelry" ),
					"param_name"        => "counter_value_plus",
					"value"             => "false",
					"on"				=> esc_html__( 'Yes', "wdjewelry" ),
					"off"				=> esc_html__( 'No', "wdjewelry" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
					"description"       => esc_html__( "Switch the toggle to either show or hide a '+' sign after the number once the count has finished.", "wdjewelry" ),
                    "dependency"		=> array( 'element' => "counter_value_format", 'value' => 'true' ),
					"group" 			=> "Value Settings",
				),
                array(
                    "type"              => "dropdown",
                    "heading"           => esc_html__( "Thousand Seperator", "wdjewelry" ),
                    "param_name"        => "counter_value_seperator",
                    "width"             => 150,
                    "value"             => array(
                        esc_html__( 'None', "wdjewelry" )         => "",
                        esc_html__( 'Comma', "wdjewelry" )        => ",",
                        esc_html__( 'Dot', "wdjewelry" )          => ".",
                        esc_html__( 'Space', "wdjewelry" )        => " ",
                    ),
                    "description"       => esc_html__( "Select a character to seperate thousands in the end number.", "wdjewelry" ),
                    "dependency"		=> array( 'element' => "counter_value_format", 'value' => 'true' ),
					"group" 			=> "Value Settings",
                ),
                array(
                    "type"              => "textfield",
                    "heading"           => esc_html__( "Character(s) before Number", "wdjewelry" ),
                    "param_name"        => "counter_value_before",
                    "value"             => "",
                    "description"       => esc_html__( "Enter any character to be shown before the nunber (i.e. $).", "wdjewelry" ),
                    "dependency"		=> array( 'element' => "counter_value_format", 'value' => 'true' ),
					"group" 			=> "Value Settings",
                ),
                array(
                    "type"              => "textfield",
                    "heading"           => esc_html__( "Character(s) after Number", "wdjewelry" ),
                    "param_name"        => "counter_value_after",
                    "value"             => "",
                    "description"       => esc_html__( "Enter any character to be shown after the nunber (i.e. %).", "wdjewelry" ),
                    "dependency"		=> array( 'element' => "counter_value_format", 'value' => 'true' ),
					"group" 			=> "Value Settings",
                ),
				array(
					"type"				=> "switch_button",
					"heading"           => esc_html__( "Seperator Line", "wdjewelry" ),
					"param_name"        => "counter_seperator",
					"value"             => "false",
					"on"				=> esc_html__( 'Yes', "wdjewelry" ),
					"off"				=> esc_html__( 'No', "wdjewelry" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
					"description"       => esc_html__( "Switch the toggle to either show or hide a seperator.", "wdjewelry" ),
                    "dependency"		=> "",
					"group" 			=> "Value Settings",
				),
                array(
                    "type"              => "textfield",
                    "heading"           => esc_html__( "Counter Note", "wdjewelry" ),
                    "param_name"        => "counter_note",
                    "value"             => "",
                    "admin_label"       => true,
                    "description"       => esc_html__( "Enter a note about what you are counting.", "wdjewelry" ),
					"group" 			=> "Value Settings",
                ),
				array(
					"type"              => "nouislider",
					"heading"           => esc_html__( "Counter Note Font Size", "wdjewelry" ),
					"param_name"        => "counter_note_size",
					"value"             => "15",
					"min"               => "12",
					"max"               => "200",
					"step"              => "1",
					"unit"              => 'px',
					"description"       => esc_html__( "Select the font size for the counter note.", "wdjewelry" ),
					"dependency"        => "",
					"group" 			=> "Value Settings",
				),
				array(
					"type"              => "colorpicker",
					"heading"           => esc_html__( "Counter Note Font Color", "wdjewelry" ),
					"param_name"        => "counter_note_color",
					"value"             => "#000000",
					"description"       => esc_html__( "Define the font color for counter note.", "wdjewelry" ),
					"dependency"        => "",
					"group" 			=> "Value Settings",
				),
				array(
					"type"              => "nouislider",
					"heading"           => esc_html__( "Counter Speed", "wdjewelry" ),
					"param_name"        => "counter_speed",
					"value"             => "2000",
					"min"               => "500",
					"max"               => "10000",
					"step"              => "100",
					"unit"              => 'ms',
					"description"       => esc_html__( "Select the speed in ms for the counter to finish.", "wdjewelry" ),
					"dependency"        => "",
					"group" 			=> "Value Settings",
				),
				// Counter Tooltip
				array(
					"type"				=> "seperator",
					"heading"			=> esc_html__( "", "wdjewelry" ),
					"param_name"		=> "seperator_4",
					"value"				=> "",
					"seperator"			=> "Icon Tooltip",
					"description"		=> esc_html__( "", "wdjewelry" ),
					"group" 			=> "Tooltip Settings",
				),
				array(
					"type"              => "switch_button",
					"heading"           => esc_html__( "Use HTML Tooltip", "wdjewelry" ),
					"param_name"        => "tooltip_html",
					"value"             => "false",
					"on"				=> esc_html__( 'Yes', "wdjewelry" ),
					"off"				=> esc_html__( 'No', "wdjewelry" ),
					"style"				=> "select",
					"design"			=> "toggle-light",
					"description"		=> esc_html__( "Switch the toggle if you want to apply a tooltip with HTML code to the element.", "wdjewelry" ),
					"group" 			=> "Tooltip Settings",
				),
				array(
					"type"				=> "textarea",
					"class"				=> "",
					"heading"			=> esc_html__( "Tooltip Content", "wdjewelry" ),
					"param_name"		=> "tooltip_content",
					"value"				=> "",
					"description"		=> esc_html__( "Enter the tooltip content here (do not use quotation marks).", "wdjewelry" ),
					"dependency"		=> array( 'element' => "tooltip_html", 'value' => 'false' ),
					"group" 			=> "Tooltip Settings",
				),
				array(
					"type"              => "textarea_raw_html",
					"heading"           => esc_html__( "Tooltip Content", "wdjewelry" ),
					"param_name"        => "tooltip_encoded",
					"value"             => "",
					"description"      	 => esc_html__( "Enter the tooltip content here (HTML code can be used).", "wdjewelry" ),
					"dependency"           => array( 'element' => "tooltip_html", 'value' => "true" ),
					"group" 			=> "Tooltip Settings",
				),
				array(
					"type"				=> "dropdown",
					"class"				=> "",
					"heading"			=> esc_html__( "Tooltip Position", "wdjewelry" ),
					"param_name"		=> "tooltip_position",
					"value"					=> array(
						__( "Top", "wdjewelry" )                            => "ts-simptip-position-top",
						__( "Bottom", "wdjewelry" )                         => "ts-simptip-position-bottom",
					),
					"description"		=> esc_html__( "Select the tooltip position in relation to the image.", "wdjewelry" ),
					"group" 			=> "Tooltip Settings",
				),
				array(
					"type"				=> "dropdown",
					"class"				=> "",
					"heading"			=> esc_html__( "Tooltip Style", "wdjewelry" ),
					"param_name"		=> "tooltip_style",
					"value"             => array(
						esc_html__( "Black", "wdjewelry" )                          => "",
						esc_html__( "Gray", "wdjewelry" )                           => "ts-simptip-style-gray",
						esc_html__( "Green", "wdjewelry" )                          => "ts-simptip-style-green",
						esc_html__( "Blue", "wdjewelry" )                           => "ts-simptip-style-blue",
						esc_html__( "Red", "wdjewelry" )                            => "ts-simptip-style-red",
						esc_html__( "Orange", "wdjewelry" )                         => "ts-simptip-style-orange",
						esc_html__( "Yellow", "wdjewelry" )                         => "ts-simptip-style-yellow",
						esc_html__( "Purple", "wdjewelry" )                         => "ts-simptip-style-purple",
						esc_html__( "Pink", "wdjewelry" )                           => "ts-simptip-style-pink",
						esc_html__( "White", "wdjewelry" )                          => "ts-simptip-style-white"
					),
					"description"		=> esc_html__( "Select the tooltip style.", "wdjewelry" ),
					"group" 			=> "Tooltip Settings",
				),
				array(
					"type"				=> "nouislider",
					"heading"			=> esc_html__( "Tooltip X-Offset", "wdjewelry" ),
					"param_name"		=> "tooltipster_offsetx",
					"value"				=> "0",
					"min"				=> "-100",
					"max"				=> "100",
					"step"				=> "1",
					"unit"				=> 'px',
					"description"		=> esc_html__( "Define an optional X-Offset for the tooltip position.", "wdjewelry" ),
					"group" 			=> "Tooltip Settings",
				),
				array(
					"type"				=> "nouislider",
					"heading"			=> esc_html__( "Tooltip Y-Offset", "wdjewelry" ),
					"param_name"		=> "tooltipster_offsety",
					"value"				=> "0",
					"min"				=> "-100",
					"max"				=> "100",
					"step"				=> "1",
					"unit"				=> 'px',
					"description"		=> esc_html__( "Define an optional Y-Offset for the tooltip position.", "wdjewelry" ),
					"group" 			=> "Tooltip Settings",
				),
				// Link Settings
				array(
					"type"              => "seperator",
					"heading"           =>esc_html__( "", "wdjewelry" ),
					"param_name"        => "seperator_5",
					"value"				=> "",
					"seperator"			=> "Link Settings",
					"description"       => esc_html__( "", "wdjewelry" ),
					"group" 			=> "Link Settings",
				),
				array(
					"type"				=> "dropdown",
					"class"				=> "",
					"heading"			=> esc_html__( "Link Holder", "wdjewelry" ),
					"param_name"		=> "link_counter",
					"value"             => array(
						esc_html__( "No Link", "wdjewelry" )                          	=> "",
						esc_html__( "Link On Icon / Image", "wdjewelry" )				=> "icon",
						esc_html__( "Link On Content", "wdjewelry" )					=> "content",
						esc_html__( "Link On Button", "wdjewelry" )						=> "flat",
						esc_html__( "Link On Full Element", "wdjewelry" )				=> "element",
					),
					"description"		=> esc_html__( "Select where the link should be attached to.", "wdjewelry" ),
					"group" 			=> "Link Settings",
				),
				array(
					"type" 				=> "vc_link",
					"heading" 			=> esc_html__("Link + Title", "wdjewelry"),
					"param_name" 		=> "link_data",
					"description" 		=> esc_html__("Provide a link to another site/page for the Icon Counter.", "wdjewelry"),
					"dependency"        => array( 'element' => "link_counter", 'value' => array('icon', 'content', 'flat', 'element') ),
					"group"				=> "Link Settings",
				),
                array(
                    "type"				=> "dropdown",
                    "heading"			=> esc_html__( "Button Color Style", "wdjewelry" ),
                    "param_name"		=> "link_buttonstyle",
                    "width"				=> 300,
					/*"value"				=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Flat_Button_Default_Colors,*/
					"value"				=> '',
                    "description"		=> esc_html__( "Select the general color style for button.", "wdjewelry" ),
					"dependency"		=> array( 'element' => "link_counter", 'value' => array('flat') ),
					"group"				=> "Link Settings",
                ),
                array(
                    "type"				=> "dropdown",
                    "heading"			=> esc_html__( "Button Hover Style", "wdjewelry" ),
                    "param_name"		=> "link_buttonhover",
                    "width"				=> 300,
					/*"value"				=> $VISUAL_COMPOSER_EXTENSIONS->TS_VCSC_Flat_Button_Hover_Colors,*/
					"value"				=>  '',
                    "description"		=> esc_html__( "Select the general hover style for button.", "wdjewelry" ),
					"dependency"		=> array( 'element' => "link_counter", 'value' => array('flat') ),
					"group"				=> "Link Settings",
                ),
                array(
                    "type"				=> "textfield",
                    "heading"			=> esc_html__( "Button Text", "wdjewelry" ),
                    "param_name"		=> "link_buttontext",
                    "value"				=> "Learn More",
                    "description"		=> esc_html__( "Enter the text for the button.", "wdjewelry" ),
					"dependency"		=> array( 'element' => "link_counter", 'value' => array('flat') ),
					"group"				=> "Link Settings",
                ),
                array(
                    "type"				=> "nouislider",
                    "heading"			=> esc_html__( "Button Text Size", "wdjewelry" ),
                    "param_name"		=> "link_buttonsize",
                    "value"				=> "16",
                    "min"				=> "12",
                    "max"				=> "20",
                    "step"				=> "1",
                    "unit"				=> 'px',
                    "description"		=> esc_html__( "Select the font size for the trigger button.", "wdjewelry" ),
					"dependency"		=> array( 'element' => "link_counter", 'value' => array('flat') ),
					"group"				=> "Link Settings",
                ),				
                // Animation
				array(
					"type"              => "seperator",
					"heading"           => esc_html__( "", "wdjewelry" ),
					"param_name"        => "seperator_6",
					"value"				=> "",
					"seperator"			=> "Icon / Image Animation",
					"description"       => esc_html__( "", "wdjewelry" ),
					"group" 			=> "Other Settings",
				),
				array(
					"type"				=> "css3animations",
					"class"				=> "",
					"heading"			=> esc_html__("Icon / Image Animation", "wdjewelry"),
					"param_name"		=> "animation_icon",
					"standard"			=> "false",
					"prefix"			=> "",
					"connector"			=> "css3animations_in",
					"noneselect"		=> "true",
					"default"			=> "",
					"value"				=> "",
					"admin_label"		=> false,
					"description"		=> esc_html__("Select the animation for the icon / image.", "wdjewelry"),
					"group" 			=> "Other Settings",
				),
				array(
					"type"				=> "hidden_input",
					"heading"			=> esc_html__( "Icon / Image Animation", "wdjewelry" ),
					"param_name"		=> "css3animations_in",
					"value"				=> "",
					"admin_label"		=> true,
					"description"		=> esc_html__( "", "wdjewelry" ),
					"group" 			=> "Other Settings",
				),
				// Other Icon Settings
				array(
					"type"              => "seperator",
					"heading"           => esc_html__( "", "wdjewelry" ),
					"param_name"        => "seperator_7",
					"value"				=> "",
					"seperator"			=> "Other Settings",
					"description"       => esc_html__( "", "wdjewelry" ),
					"group" 			=> "Other Settings",
				),
                array(
                    "type"              => "nouislider",
                    "heading"           => esc_html__( "Margin: Top", "wdjewelry" ),
                    "param_name"        => "margin_top",
                    "value"             => "0",
                    "min"               => "-50",
                    "max"               => "500",
                    "step"              => "1",
                    "unit"              => 'px',
                    "description"       => esc_html__( "Select the top margin for the element.", "wdjewelry" ),
					"group" 			=> "Other Settings",
                ),
                array(
                    "type"              => "nouislider",
                    "heading"           => esc_html__( "Margin: Bottom", "wdjewelry" ),
                    "param_name"        => "margin_bottom",
                    "value"             => "0",
                    "min"               => "-50",
                    "max"               => "500",
                    "step"              => "1",
                    "unit"              => 'px',
                    "description"       => esc_html__( "Select the bottom margin for the element.", "wdjewelry" ),
					"group" 			=> "Other Settings",
                ),
				array(
					"type"              => "textfield",
					"heading"           => esc_html__( "Define ID Name", "wdjewelry" ),
					"param_name"        => "el_id",
					"value"             => "",
					"description"       => esc_html__( "Enter an unique ID for the element.", "wdjewelry" ),
					"group" 			=> "Other Settings",
				),
				array(
					"type"              => "textfield",
					"heading"           => esc_html__( "Extra Class Name", "wdjewelry" ),
					"param_name"        => "el_class",
					"value"             => "",
					"description"       => esc_html__( "Enter a class name for the element.", "wdjewelry" ),
					"group" 			=> "Other Settings",
				),
				// Load Custom CSS/JS File
				array(
					"type"				=> "load_file",
					"heading"			=> esc_html__( "", "wdjewelry" ),
					"value"				=> "",
					"param_name"		=> "el_file1",
					"file_type"			=> "js",
					"file_path"			=> "js/ts-visual-composer-extend-element.min.js",
					"description"		=> esc_html__( "", "wdjewelry" )
				),
				array(
					"type"				=> "load_file",
					"heading"			=> esc_html__( "", "wdjewelry" ),
					"value"				=> "",
					"param_name"		=> "el_file2",
					"file_type"			=> "css",
					"file_id"			=> "ts-extend-animations",
					"file_path"			=> "css/ts-visual-composer-extend-animations.min.css",
					"description"		=> esc_html__( "", "wdjewelry" )
				),
				
	)
);
vc_map( $specipic_product_params );
 
?>
